Index: trunk/src/lib/collision_detection/bounding_sphere.cc
===================================================================
--- trunk/src/lib/collision_detection/bounding_sphere.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/bounding_sphere.cc	(revision 7711)
@@ -1,3 +1,3 @@
-/* 
+/*
    orxonox - the future of 3D-vertical-scrollers
 
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "bounding_sphere.h"
@@ -24,7 +24,7 @@
  *  standard constructor
 */
-BoundingSphere::BoundingSphere () 
+BoundingSphere::BoundingSphere ()
 {
-   this->setClassID(CL_BOUNDING_SPHERE, "BoundingSphere"); 
+   this->setClassID(CL_BOUNDING_SPHERE, "BoundingSphere");
 }
 
@@ -34,5 +34,5 @@
 
 */
-BoundingSphere::~BoundingSphere () 
+BoundingSphere::~BoundingSphere ()
 {
   // delete what has to be deleted here
Index: trunk/src/lib/collision_detection/bounding_volume.cc
===================================================================
--- trunk/src/lib/collision_detection/bounding_volume.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/bounding_volume.cc	(revision 7711)
@@ -14,8 +14,7 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "bounding_volume.h"
-#include "vector.h"
 
 using namespace std;
@@ -27,8 +26,8 @@
 BoundingVolume::BoundingVolume ()
 {
-   this->setClassID(CL_BOUNDING_VOLUME, "BoundingVolume");
-   this->center = new Vector();
-   this->bOrigVertices = true;
-   this->vertices = NULL;
+  this->setClassID(CL_BOUNDING_VOLUME, "BoundingVolume");
+  this->modelInf = NULL;
+  this->triangleIndexes = NULL;
+  this->triangleIndexesLength = 0;
 }
 
@@ -40,8 +39,5 @@
 BoundingVolume::~BoundingVolume ()
 {
-  // delete what has to be deleted here
-  delete this->center;
-
-  if( this->vertices && !this->bOrigVertices)
-    delete[] this->vertices;
+  if( this->triangleIndexes)
+    delete[] this->triangleIndexes;
 }
Index: trunk/src/lib/collision_detection/bounding_volume.h
===================================================================
--- trunk/src/lib/collision_detection/bounding_volume.h	(revision 7677)
+++ trunk/src/lib/collision_detection/bounding_volume.h	(revision 7711)
@@ -11,5 +11,5 @@
 #include "model.h"
 
-class Vector;
+
 template<class T> class tList;
 
@@ -22,7 +22,7 @@
     virtual ~BoundingVolume();
 
-    inline const Vector* getCenter() const { return this->center; }
+    inline const Vector& getCenter() const { return this->center; }
+    inline const modelInfo* getModelInfo() const { return this->modelInf; }
 
-    const sVec3D* getVertices() const { return this->vertices; }
     virtual void mergeWith(const BoundingVolume &bv) = 0;
 
@@ -32,9 +32,10 @@
 
   public:
-    Vector*             center;                     //!< Center point of box
+    Vector              center;                     //!< Weighter average center point of box
+    Vector              arithCenter;                //!< Arithmetical center of the box
 
-    const sVec3D*       vertices;                   //!< if CD_STORE_VERTICES enabled, this is the place, where the vert. will be sotred
-    int                 numOfVertices;              //!< number of vertices in the vertices buffer
-    bool                bOrigVertices;              //!< is true if the vertices pointer points to the original model data - only important for deleting
+    const modelInfo*    modelInf;                   //!< Reference to the model's ModelInfo
+    const int*          triangleIndexes;            //!< Array with the triangle indexes in modelInfo
+    int                 triangleIndexesLength;      //!< length of the indexes array
 };
 
Index: trunk/src/lib/collision_detection/bv_tree.cc
===================================================================
--- trunk/src/lib/collision_detection/bv_tree.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/bv_tree.cc	(revision 7711)
@@ -1,3 +1,3 @@
-/* 
+/*
    orxonox - the future of 3D-vertical-scrollers
 
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "bv_tree.h"
@@ -25,7 +25,7 @@
  *  standard constructor
 */
-BVTree::BVTree () 
+BVTree::BVTree ()
 {
-   this->setClassID(CL_BV_TREE, "BVTree"); 
+   this->setClassID(CL_BV_TREE, "BVTree");
 
 }
@@ -36,5 +36,5 @@
 
 */
-BVTree::~BVTree () 
+BVTree::~BVTree ()
 {
   // delete what has to be deleted here
Index: trunk/src/lib/collision_detection/bv_tree.h
===================================================================
--- trunk/src/lib/collision_detection/bv_tree.h	(revision 7677)
+++ trunk/src/lib/collision_detection/bv_tree.h	(revision 7711)
@@ -18,4 +18,5 @@
 class WorldEntity;
 
+//! draw mode for the bounding volume
 typedef enum DrawMode
 {
@@ -33,27 +34,17 @@
 
 //! A class that represents a bounding volume tree
-class BVTree : public BaseObject {
+class BVTree : public BaseObject
+{
 
- public:
-  BVTree();
-  virtual ~BVTree();
+  public:
+    BVTree();
+    virtual ~BVTree();
 
-  virtual void spawnBVTree(int depth, sVec3D *verticesList, const int length) = 0;
-  virtual void spawnBVTree(int depth, const modelInfo& modInfo) = 0;
-  virtual void flushTree() = 0;
+    virtual void spawnBVTree(const modelInfo& modelInf) = 0;
+    virtual void flushTree() = 0;
 
-  virtual void collideWith(BVTree* tree, WorldEntity* nodeA, WorldEntity* nodeB) = 0;
-  virtual void collideWith(WorldEntity* entity1, WorldEntity* entity2) = 0;
+    virtual void collideWith(WorldEntity* entity1, WorldEntity* entity2) = 0;
 
-  /** @param depth: depth, @param drawMode: how to draw the Model */
-  virtual void drawBV(int depth, int drawMode) const = 0;
-
-
- protected:
-  int numberOfVertices;
-
- private:
-
-
+    virtual void drawBV(int depth, int drawMode) const = 0;
 };
 
Index: trunk/src/lib/collision_detection/bv_tree_node.cc
===================================================================
--- trunk/src/lib/collision_detection/bv_tree_node.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/bv_tree_node.cc	(revision 7711)
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "bv_tree_node.h"
Index: trunk/src/lib/collision_detection/bv_tree_node.h
===================================================================
--- trunk/src/lib/collision_detection/bv_tree_node.h	(revision 7677)
+++ trunk/src/lib/collision_detection/bv_tree_node.h	(revision 7711)
@@ -8,9 +8,11 @@
 #define _BV_TREE_NODE_H
 
+
 #include "base_object.h"
 #include "model.h"
 #include "vector.h"
 
-// FORWARD DECLARATION
+
+// forward declarations
 class BoundingVolume;
 class BVTree;
@@ -19,6 +21,8 @@
 template<class T> class tList;
 
+
 //! A class that represents a bounding volume tree
 class BVTreeNode : public BaseObject {
+
 
  public:
@@ -26,12 +30,10 @@
   virtual ~BVTreeNode();
 
-  virtual void spawnBVTree(const int depth, const sVec3D *verticesList, unsigned int length ) = 0;
-  virtual void spawnBVTree(const int depth, const modelInfo& modInfo) = 0;
+  virtual const BoundingVolume* getBV() const = 0;
+  /** returns the index of this bounding volume tree node @returns index of this index */
+  inline const int getIndex() const { return this->treeIndex; }
 
-  virtual BoundingVolume* getBV(int index) const = 0;
-  inline const int getIndex() { return this->treeIndex; }
-
+  virtual void spawnBVTree(const modelInfo& modInfo, const int* triangleIndexes, int length) = 0;
   virtual void collideWith(BVTreeNode* treeNode, WorldEntity* nodeA, WorldEntity* nodeB) = 0;
-
   virtual void drawBV(int depth, int drawMode, const Vector& color = Vector(1,0,0), bool top = true) const = 0;
 
Index: trunk/src/lib/collision_detection/cd_engine.cc
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/cd_engine.cc	(revision 7711)
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "cd_engine.h"
@@ -40,4 +40,6 @@
 {
   this->setClassID(CL_CD_ENGINE, "CDEngine");
+
+  this->bAbordOnFirstCollision = false;
 }
 
@@ -59,56 +61,11 @@
 
 /**
- *  this is the collision checking function
-
-    there are some speed improvements that can be done here. a rewrite of the list a would be appropriate to
-    be able to enhance iteration speed.
+ *
  */
-//void CDEngine::checkCollisions()
-//{
-//  this->checkCollisionObjects();
-  //this->checkCollisionGround();
-//}
-
-/**
- *  this checks the collisions with the objects
- */
-//void CDEngine::checkCollisionObjects()
-//{
-//   BVTree* tree;
-//   tIterator<WorldEntity>* iterator1 = entityList->getIterator();
-//   tIterator<WorldEntity>* iterator2 = entityList->getIterator();
-//   WorldEntity* entity1 = iterator1->firstElement();
-//   WorldEntity* entity2 = iterator2->iteratorElement(iterator1);
-//   PRINTF(3)("checking for collisions\n");
-//   while( entity1 != NULL)
-//   {
-//     if( likely(entity1 != this->terrain))
-//     {
-//       entity2 = iterator2->nextElement();
-//
-//       while( entity2 != NULL)
-//       {
-//         if( likely(entity2 != this->terrain))
-//         {
-//           PRINTF(4)("checking object %s against %s\n", entity1->getName(), entity2->getName());
-//           tree = entity1->getOBBTree();
-//           if( likely(tree != NULL) && entity2->getOBBTree() != NULL) tree->collideWith(entity1, entity2);
-//         }
-//         entity2 = iterator2->nextElement();
-//       }
-//     }
-//     entity1 = iterator1->nextElement();
-//     entity2 = iterator2->iteratorElement(iterator1);
-//     entity2 = iterator2->nextElement();
-//   }
-//   delete iterator1;
-//   delete iterator2;
-//}
-
 void CDEngine::checkCollisions(ObjectManager::EntityList& list1, ObjectManager::EntityList& list2)
 {
   BVTree* tree;
   ObjectManager::EntityList::iterator entity1, entity2, pre1, pre2;
-  PRINTF(3)("checking for collisions\n");
+  PRINTF(5)("checking for collisions\n");
 
   pre1 = list1.begin();
@@ -126,5 +83,6 @@
           PRINTF(4)("checking object %s against %s\n", (*entity1)->getName(), (*entity2)->getName());
           tree = (*entity1)->getOBBTree();
-          if( likely(tree != NULL) && (*entity2)->getOBBTree() != NULL) tree->collideWith(*entity1, *entity2);
+          if( likely(tree != NULL) && (*entity2)->getOBBTree() != NULL)
+            tree->collideWith(*entity1, *entity2);
         }
       }
@@ -150,25 +108,4 @@
 
 /**
- *  this draws the bounding volume tree
- * @param depth until which depth to draw the tree
- * @param drawMode mod which states how to draw it
- */
-void CDEngine::drawBV(int depth, int drawMode) const
-{
-  /* this would operate on  worldList bases, for testing purposes, we only use one OBBTree */
-  //this->rootTree->drawBV(depth, drawMode);
-  /// FIXME
-/*  tIterator<WorldEntity>* iterator = entityList->getIterator();
-  WorldEntity* entity = iterator->firstElement();
-  while( entity != NULL)
-  {
-    entity->drawBVTree(depth, drawMode);
-    entity = iterator->nextElement();
-  }
-  delete iterator;*/
-}
-
-
-/**
  * some debug output on the class
  */
@@ -189,7 +126,6 @@
 void CDEngine::debugSpawnTree(int depth, sVec3D* vertices, int numVertices)
 {
-  if ( this->rootTree == NULL)
-    this->rootTree = new OBBTree();
-  this->rootTree->spawnBVTree(depth, vertices, numVertices);
+//   if ( this->rootTree == NULL)
+//     this->rootTree = new OBBTree(depth, vertices, numVertices);
 }
 
@@ -199,6 +135,5 @@
   ObjectManager::EntityList::const_iterator entity;
   for (entity = drawList.begin(); entity != drawList.end(); entity++)
-    if ((*entity)->isVisible())
-      (*entity)->drawBVTree(3, 226);
+    (*entity)->drawBVTree(3, 226);
 }
 
@@ -208,5 +143,5 @@
 void CDEngine::debugDraw(int depth, int drawMode)
 {
-  if(this-> rootTree != NULL)
-    this->rootTree->drawBV(depth, drawMode);
+//   if(this-> rootTree != NULL)
+//     this->rootTree->drawBV(depth, drawMode);
 }
Index: trunk/src/lib/collision_detection/cd_engine.h
===================================================================
--- trunk/src/lib/collision_detection/cd_engine.h	(revision 7677)
+++ trunk/src/lib/collision_detection/cd_engine.h	(revision 7711)
@@ -50,9 +50,5 @@
 
   inline void setTerrain(Terrain* terrain) { this->terrain = terrain; }
-  //  inline void setPlayer(Player* player) { this->player = player; } /* only for debug purposes \todo: delete*/
 
-  void drawBV(int depth, int drawMode) const;
-
-//  void checkCollisions();
   void checkCollisions(std::list<WorldEntity*>& list1, std::list<WorldEntity*>& list2);
 
@@ -76,8 +72,8 @@
  private:
   int                     state;                            //!< the current state of the cd engine
+  bool                    bAbordOnFirstCollision;           //!< abords the collision detection on first collision event => more speed but less accurate infomations
   OBBTree*                rootTree;                         //!< for testing purposes a root tree
 
   Terrain*                terrain;                          //!< this it a ref to the terrain, serving as a ground for all WE
-//  Player*                 player;
 };
 
Index: trunk/src/lib/collision_detection/collision.cc
===================================================================
--- trunk/src/lib/collision_detection/collision.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/collision.cc	(revision 7711)
@@ -1,3 +1,3 @@
-/* 
+/*
    orxonox - the future of 3D-vertical-scrollers
 
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "collision.h"
@@ -24,7 +24,7 @@
  *  standard constructor
 */
-Collision::Collision () 
+Collision::Collision ()
 {
-   this->setClassID(CL_COLLISION, "Collision"); 
+   this->setClassID(CL_COLLISION, "Collision");
 
 }
@@ -35,5 +35,5 @@
 
 */
-Collision::~Collision () 
+Collision::~Collision ()
 {
   // delete what has to be deleted here
Index: trunk/src/lib/collision_detection/obb.cc
===================================================================
--- trunk/src/lib/collision_detection/obb.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/obb.cc	(revision 7711)
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "obb.h"
@@ -28,6 +28,5 @@
 {
    this->setClassID(CL_OBB, "OBB");
-   this->axis = new Vector[3];
-   this->halfLength = new float[3];
+   this->halfLength[0] = this->halfLength[1] = this->halfLength[2] = 0.0f;
    this->bCollided = false;
 }
@@ -40,6 +39,4 @@
 OBB::~OBB ()
 {
-  delete [] this->axis;
-  delete [] this->halfLength;
 }
 
Index: trunk/src/lib/collision_detection/obb.h
===================================================================
--- trunk/src/lib/collision_detection/obb.h	(revision 7677)
+++ trunk/src/lib/collision_detection/obb.h	(revision 7711)
@@ -21,5 +21,8 @@
 
 
-  inline Vector* getAxis () const { return this->axis; }
+  inline Vector getAxisX () const { return this->axis[0]; }
+  inline Vector getAxisY () const { return this->axis[1]; }
+  inline Vector getAxisZ () const { return this->axis[2]; }
+
   inline const float* getHalfLength() const { return this->halfLength; }
 
@@ -31,6 +34,6 @@
 
  public:
-  Vector*          axis;                       //!< Axes of oriented box [x,y,z]
-  float*           halfLength;                 //!< Half lengths of the box along the axis
+  Vector           axis[3];                    //!< Axes of oriented box [x,y,z]
+  float            halfLength[3];              //!< Half lengths of the box along the axis
   float            covarianceMatrix[3][3];     //!< the covariance matrix
 
Index: trunk/src/lib/collision_detection/obb_tree.cc
===================================================================
--- trunk/src/lib/collision_detection/obb_tree.cc	(revision 7677)
+++ trunk/src/lib/collision_detection/obb_tree.cc	(revision 7711)
@@ -14,5 +14,5 @@
 */
 
-#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION
+#define DEBUG_SPECIAL_MODULE DEBUG_MODULE_COLLISION_DETECTION
 
 #include "obb_tree.h"
@@ -31,19 +31,11 @@
  *  standard constructor
 */
-OBBTree::OBBTree ()
+OBBTree::OBBTree(int depth, const modelInfo* modelInf, WorldEntity* owner)
+  : BVTree()
 {
+  this->depth = depth;
   this->init();
-}
-
-OBBTree::OBBTree(int depth, sVec3D *verticesList, const int length)
-{
-  this->init();
-  this->spawnBVTree(depth, verticesList, length);
-}
-
-OBBTree::OBBTree(int depth, const modelInfo& modInfo)
-{
-  this->init();
-  this->spawnBVTree(depth, modInfo);
+  this->spawnBVTree(*modelInf);
+  this->owner = owner;
 }
 
@@ -53,7 +45,5 @@
 {
   this->setClassID(CL_OBB_TREE, "OBBTree");
-
   this->rootNode = NULL;
-
   this->id = 0;
 }
@@ -69,19 +59,9 @@
 
 
-void OBBTree::spawnBVTree(int depth, sVec3D *verticesList, const int length)
-{
-  if( unlikely(this->rootNode != NULL))
-    {
-      PRINTF(2)("The BVTree has already been spawned, flushing and respawning again...\n");
-      this->flushTree();
-    }
-  OBBTreeNode* node = new OBBTreeNode();
-  this->rootNode = node;
-  this->rootNode->setTreeRef(this);
-  this->rootNode->spawnBVTree(--depth, verticesList, length);
-}
-
-
-void OBBTree::spawnBVTree(int depth, const modelInfo& modInfo)
+/**
+ *  this function creates a bv tree out of a modelInf structure
+ * @param modelInf the model info of a model (modelInfo), containing vertices, triangle and normal infos
+ */
+void OBBTree::spawnBVTree(const modelInfo& modelInf)
 {
   if( unlikely(this->rootNode != NULL))
@@ -90,15 +70,27 @@
     this->flushTree();
   }
-  OBBTreeNode* node = new OBBTreeNode();
-  this->rootNode = node;
-  this->rootNode->setTreeRef(this);
-  this->rootNode->spawnBVTree(--depth, modInfo);
+  this->rootNode = new OBBTreeNode(*this, NULL, depth-1);
+
+  /* triangles indexes created */
+  int* triangleIndexes = new int[modelInf.numTriangles];
+  for( int i = 0; i < modelInf.numTriangles; ++i)
+    triangleIndexes[i] = i;
+
+  this->rootNode->spawnBVTree(modelInf, triangleIndexes, modelInf.numTriangles);
 }
 
 
+/**
+ *  release the current bv tree if any
+ */
 void OBBTree:: flushTree()
 {}
 
 
+/**
+ * this collides two bvtrees together. the trees are attached to pnodes Objects A and B
+ * @param nodeA: PNode of object A
+ * @param nodeB: Pnode of object B
+ */
 void OBBTree::collideWith(WorldEntity* entity1, WorldEntity* entity2)
 {
@@ -109,15 +101,6 @@
 
 /**
- * this collides two bvtrees together. the trees are attached to pnodes Objects A and B
- * @param tree: the other tree to collide with (Object B)
- * @param nodeA: PNode of object A
- * @param nodeB: Pnode of object B
+ *  draw bv tree
  */
-void OBBTree::collideWith(BVTree* tree, WorldEntity* nodeA, WorldEntity* nodeB)
-{
-  this->rootNode->collideWith(((OBBTree*)tree)->getRootNode(), nodeA, nodeB);
-}
-
-
 void OBBTree::drawBV(int depth, int drawMode) const
 {
@@ -129,5 +112,9 @@
 
 
-
+/**
+ *  some debug output and creation function
+ *
+ * doesn't work at the moment
+ */
 void OBBTree::debug()
 {
@@ -153,5 +140,5 @@
     }
 
-  this->spawnBVTree(3, vertList, length);
+//   this->spawnBVTree(vertList, length);
 
   PRINT(0)("=  Spawning Tree: Finished\n");
Index: trunk/src/lib/collision_detection/obb_tree.h
===================================================================
--- trunk/src/lib/collision_detection/obb_tree.h	(revision 7677)
+++ trunk/src/lib/collision_detection/obb_tree.h	(revision 7711)
@@ -15,26 +15,26 @@
 class OBBTreeNode;
 class PNode;
+class WorldEntity;
 
 //! A class for representing an obb tree
-class OBBTree : public BVTree {
+class OBBTree : public BVTree
+{
 
   public:
-    OBBTree();
-    OBBTree(int depth, sVec3D *verticesList, const int length);
-    OBBTree(int depth, const modelInfo& modInfo);
+    OBBTree(int depth, const modelInfo* modInfo, WorldEntity* entity);
     virtual ~OBBTree();
     void init();
 
-    virtual void spawnBVTree(int depth, sVec3D *verticesList, const int length);
-    virtual void spawnBVTree(int depth, const modelInfo& modInfo);
+    virtual void spawnBVTree(const modelInfo& modelInf);
     virtual void flushTree();
 
-    virtual void collideWith(BVTree* tree, WorldEntity* nodeA, WorldEntity* nodeB);
     virtual void collideWith(WorldEntity* entity1, WorldEntity* entity2);
-
     virtual void drawBV(int depth, int drawMode) const;
 
-    int getID() { return ++this->id;}
-    inline OBBTreeNode* getRootNode() { return this->rootNode; }
+    /** returns the next if for the obb tree node @return integer id number of the next node */
+    inline const int getID() { return ++this->id;}
+    /** returns the root node of the bounding volume tree @return reference to the root node */
+    inline OBBTreeNode* getRootNode() const { return this->rootNode; }
+    inline WorldEntity* getOwner() const { return this->owner; }
 
     void debug();
@@ -42,5 +42,7 @@
   private:
     OBBTreeNode*         rootNode;                        //!< reference to the root node of the tree
-    int                  id;
+    int                  id;                              //!< the next id of a obb tree node
+    int                  depth;                           //!< the depth of the tree to generate
+    WorldEntity*         owner;                           //!< owner
 };
 
